<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: wm/Workbench.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: wm/Workbench.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
define(['underscore', 'jquery', 'uweaver/lang', 'uweaver/theme', 'uweaver/string',
    'uweaver/widget/Widget', 'uweaver/widget/Popup', 'uweaver/widget/Trigger',
    'uweaver/widget/Toolbox', 'uweaver/wm/TaskManager', 'uweaver/widget/Icon', 
    'uweaver/Deferred', 'uweaver/i18n',
    'text!./tpl/Workbench.html'], function(_, $, lang, theme, string, Widget, Popup, Trigger, Toolbox, TaskManager, Icon, Deferred, i18n, tpl) {

    var declare = lang.declare;
    var Base = Widget;

    /**
     * A workbench is a window manager designed to provide a desktop-like environment.
     *
     * #### Configs ####
     * - tpl(String): A html string to layout &amp; construct the DOM.
     * - site(String): The site id.
     *
     * @constructor Workbench
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - The configuration of the workbench.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this._cfg;

        _.defaults(cfg, defaults);
        this._anchors = {
            $titlebar: undefined,
            $workspace: undefined,
            $menu: undefined
        };


        this._icon = new Icon().render();

        cfg.tpl = tpl;
        this._exitHandler = cfg.exitHandler;
        this._applets = cfg.applets;
        cfg.user &amp;&amp; this.user(cfg.user);
        cfg.site &amp;&amp; this.site(cfg.site);
        cfg.notification &amp;&amp; this.notification(cfg.notification);

        window.addEventListener('beforeunload', confirmExit);
        this._onUnload = _.bind(onUnload, this);
        window.addEventListener('unload', this._onUnload);

        setInterval(_.bind(heartbeat, this), 1200000);

        setInterval(_.bind(flash, this), 2000);
    }

    function confirmExit(event) {
        var confirmationMessage = i18n.translate("Are you sure you want to leave the system?", {namespace: 'message'});
        event.returnValue = confirmationMessage;

        return confirmationMessage;
    }

    function onUnload(event) {
        this.exit();
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        options || (options = {});

        var cfg = this._cfg;

        this.hide();

        var anchors = this._anchors;
        var applets = this._applets;

        anchors.$titlebar = this.$anchor("titlebar");
        anchors.$workspace = this.$anchor("workspace");
        anchors.$menu = this.$anchor("menu");

        anchors.$workspace.addClass(theme.background());
        anchors.$titlebar.addClass(theme.fill());

        applets.fetch({async:false});

        renderTitlebar.call(this);
        renderLaunchpad.call(this);
        renderTaskManager.call(this);
        renderSiteInfo.call(this);
        renderUserInfo.call(this);

        anchors.$menu.append(this._icon.$el);

        this.once('attach', _.bind(onAttached, this));

        this.attach($('body'));

        this.resize();

        heartbeat.call(this);

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function heartbeat() {
        validateSession.call(this);

        this.notification() &amp;&amp; this.notification().fetch({
            success: renderNotification,
            context: this
        });
    }

    function flash() {
        renderNotification.call(this);
    }

    function validateSession() {
        var site = this._site;

        site &amp;&amp; _.isFunction(site.validateSession) &amp;&amp; site.validateSession();
    }


    function onAttached() {
        var cfg = this._cfg;

        var fn = _.bind(this.resize, this);
        $(window).resize(fn);

        cfg.startupApplet ? this.startApplet(cfg.startupApplet) : this.home();
    }

    function resize() {
        var anchors = this._anchors;
        var workspaceHeight = $(window).height() - anchors.$titlebar.outerHeight();
        anchors.$workspace.outerHeight(workspaceHeight);
        this._launchpad.height(anchors.$workspace.outerHeight());
    }

    function home() {
        var cfg = this._cfg;

         cfg.home &amp;&amp; this.startApplet(cfg.home);
    }

    function site(model) {
        if(arguments.length===0) return this._site;

        this._site &amp;&amp; this.stopListening(this._site);

        this._site = model;

        this._site.fetch({async:false});

        renderSiteInfo.call(this);

        this.listenTo(this._site, 'change', _.bind(renderSiteInfo, this));
    }

    function renderSiteInfo() {
        var site = this._site;

        this.title(site.get('title'));
        this._icon.name(site.get('icon'));
    }

    function user(model) {
        if(arguments.length===0) return this._user;

        this._user &amp;&amp; this.stopListening(this._user);

        this._user = model;

        this.listenTo(this._user, 'change', _.bind(renderUserInfo, this));

        renderUserInfo.call(this);
    }

    function renderUserInfo() {
        var user = this._user;

        var username = _.isFunction(user.displayName) ? user.displayName() : user.id;
        this.$anchor('username').html(username);
    }

    function notification(model) {
        if(arguments.length===0) return this._notification;

        this._notification &amp;&amp; this.stopListening(this._notification);

        this._notification = model;
    }

    function renderNotification() {
        var notification = this._notification;

        _.each(this._titlebar.buttons(), function(button) {
            var msg = notification.get(button.value().toLowerCase());
            var flash = (msg) ? true : false;
            var text = msg;

            if(_.isObject(msg)) {
                flash = msg.flash;
                text = string.format(i18n.message(msg.template), msg);
            }

            button.prop('title', text);
            if(flash) {
                (button.css('color')==='rgb(255, 189, 60)') ?  button.css('color', 'white') : button.css('color', 'rgb(255, 189, 60)');
            } else {
                (button.css('color')==='rgb(255, 189, 60)')  &amp;&amp; button.css('color', 'white');
            }
        });
    }

    function title(html) {
        this.$anchor('title').html(html);
    }

    function caption(html) {
        this.$anchor('caption').html(html);
    }


    function renderTitlebar() {
        var anchors = this._anchors;
        var titlebar = new Trigger({
            el: anchors.$titlebar,
            selector: "[data-uw-anchor=button]"
        });
        titlebar.render();


        var myAccount = titlebar.$('[data-toggle=dropdown]');
        if(myAccount) {
            myAccount.attr('title', i18n.translate(myAccount.attr('title')));
        }

        this.listenTo(titlebar, 'trigger', _.bind(onCommandTrigger, this));

        this._titlebar = titlebar;
    }

    function renderLaunchpad() {
        var applets = this._applets;
        var anchors = this._anchors;

        var launchpadPopup = new Popup();

        launchpadPopup.render();
        this._launchpadPopup = launchpadPopup;

        var launchpad = new Toolbox({
            data: applets
        });

        launchpad.width("252px");

        launchpad.render();
        launchpad.on('select', _.bind(onLaunchpadSelect, this));

        launchpadPopup.content(launchpad);

        this._launchpad = launchpad;
    }

    function toggleLaunchpad() {
        var anchors = this._anchors;
        this._launchpadPopup.toggle({
            position: {
                right: 0,
                top: anchors.$titlebar.outerHeight()
            }
        });
        // first time show up
        this._launchpad.height(anchors.$workspace.outerHeight());
    }

    function onCommandTrigger(event) {
        var cfg = this.cfg();
        var value = event.data;

        switch (value.toUpperCase()) {
            case Workbench.COMMAND.HOME:
                this.home();
                break;
            case Workbench.COMMAND.LAUNCHPAD:
                toggleLaunchpad.call(this);
                break;
            case Workbench.COMMAND.TASKMANAGER:
                toggleTaskManager.call(this);
                break;
            case Workbench.COMMAND.INBOX:
                cfg.inbox ? this.startApplet(cfg.inbox) : showInbox.call(this);
                break;
            case Workbench.COMMAND.MESSENGER:
                cfg.messenger ? this.startApplet(cfg.messenger) : showMessenger.call(this);
                break;
            case Workbench.COMMAND.EXIT:
                this.exit();
                break;
            default:
                this.trigger('trigger', {
                    data: event.data,
                    source: event.source,
                    context: this
                });
                break;
        }
    }

    function onLaunchpadSelect(event) {
        var applet = event.data;
        var module = applet.get('path');
        this.startApplet(module);
        this._launchpadPopup.hide();
    }

    function startApplet(module) {
        var taskManager = this._taskManager;

        taskManager.start("applet/" + module).then(function(applet) {
            this.showApplet(applet);
            this.listenTo(applet, 'forward', _.bind(onForward, this));
            this.listenTo(applet, 'transition', _.bind(onAppletTransition, this));
        }, this);
    }

    function stopApplet(applet) {
        var taskManager = this._taskManager;

        this.hideApplet(applet);
        this.stopListening(applet);
        taskManager.stop(applet);
    }

    function showApplet(applet) {
        this.caption(applet.title());
        attachMenu.call(this, applet.menu());
        if(this._activeApplet) {
            this._activeApplet.detach();
        }
        applet.attach(this._anchors.$workspace);
        applet.height('100%');
        this.resize();
        this._activeApplet = applet;
        applet.activate &amp;&amp; applet.activate();
    }

    function hideApplet(applet) {
        if(applet!==this._activeApplet) return;
        this.caption("");
        attachMenu.call(this, undefined);
        applet.detach();
        this._activeApplet = undefined;
        applet.deactivate &amp;&amp; applet.deactivate();
    }

    function onAppletTransition(event) {
        var applet = event.context;
        if(applet!==this._activeApplet) {
            return;
        }

        this.caption(applet.title());
        attachMenu.call(this, applet.menu());
    }

    function attachMenu(menu) {
        var anchors = this._anchors;
        var $menu = anchors.$menu;

        $menu.contents().detach();

        if(menu) {
            menu.css("display", "inline-block");
            $menu.append(menu.$el);
        } else {
            $menu.append(this._icon.$el);
        }
    }

    function onForward(event) {
    }


    function renderTaskManager() {
        var anchors = this._anchors;
        var taskManagerPopup = new Popup();

        taskManagerPopup.render();
        this._taskManagerPopup = taskManagerPopup;

        var taskManager = new TaskManager();

        taskManager.render();
        taskManager.on('select', _.bind(onTaskManagerSelect, this));
        taskManager.on('stop', _.bind(onTaskManagerStop, this));

        taskManagerPopup.content(taskManager);

        this._taskManager = taskManager;
    }


    function onTaskManagerSelect(event) {
        var applet = event.data.task;
        this.showApplet(applet);
        this._taskManagerPopup.hide();
    }

    function onTaskManagerStop(event) {
        var applet = event.data.task;
        this.hideApplet(applet);
    }

    function toggleTaskManager() {
        var titlebar = this._titlebar;
        var taskManagerPopup = this._taskManagerPopup;
        var taskManagerSwitch = titlebar.get(Workbench.COMMAND.TASKMANAGER);

        taskManagerPopup.toggle({
            positionTo: taskManagerSwitch.$el
        });
    }

    function showMessenger() {}

    function showInbox() {}

    function exit() {
        if(this._exitHandler &amp;&amp; this._exitHandler()===false) {
            return;
        }

        this.destroy();
    }

    function destroy() {
        this._taskManager.destroy();
        this._taskManagerPopup.destroy();
        this._launchpadPopup.destroy();
        window.removeEventListener('beforeunload', confirmExit);
        window.removeEventListener('unload', this._onUnload);

        Base.prototype.destroy.apply(this, arguments);
    }

    var props = {
        _applets: undefined,
        _user: undefined,
        _icon: undefined,
        _site: undefined,
        _notification: undefined,

        _titlebar: undefined,
        _launchpad: undefined,
        _launchpadPopup: undefined,
        _taskManager: undefined,
        _taskManagerPopup: undefined,
        _activeTask: undefined,

        _exitHandler: undefined
    };

    var Workbench = declare(Base, {
        initialize: initialize,
        render: render,
        title: title,
        caption: caption,

        resize: resize,
        home: home,
        site: site,
        user: user,
        notification: notification,

        startApplet: startApplet,
        stopApplet: stopApplet,
        showApplet: showApplet,
        hideApplet: hideApplet,

        exit: exit,
        destroy: destroy
    }, props);

    // Enumeration of build in commands
    Workbench.COMMAND = {
        HOME: 'HOME',
        LAUNCHPAD: 'LAUNCHPAD',
        TASKMANAGER: 'TASKMANAGER',
        MESSENGER: 'MESSENGER',
        INBOX: 'INBOX',
        MENU: 'MENU',
        EXIT: 'EXIT'
    };

    return Workbench;
});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
